\RequirePackage{xr-hyper}  % for cleveref; https://tex.stackexchange.com/a/244272/121234 and https://www.latex4technics.com/?note=2uab
\documentclass[9pt,t,serif,professionalfont,xcolor={table,dvipsnames},noamsthm]{beamer}
\PassOptionsToPackage{pdfpagemode=FullScreen}{hyperref}
\setbeamersize{text margin left = 0.5cm,
               text margin right = 0.3cm}
\mode<presentation>
{
  \usetheme{boxes}
  \setbeamercovered{invisible}
  \setbeamertemplate{navigation symbols}{} 
}
\hypersetup{colorlinks=true,linkcolor=blue, urlcolor=blue} 
\definecolor{alertcolor}{RGB}{203, 0 , 34}
\setbeamercolor{alerted text}{fg=alertcolor}

\usepackage[perpage,symbol*,para,multiple]{footmisc}
% Getting undefined commands in aux file
\makeatletter
\newcommand\FN@pp@footnote@aux[2]{\relax}
\makeatother

\usepackage{../presentation,../presentationfonts}
\usepackage{../../grammar}

% load the pdfanim style, should be done after hyperref
% \usepackage{pdfanim}

% load and initialise animation
% arguments:
%   \PDFAnimLoad[options]{name}{xxx}{number}
%   - options: in this example the animation is looped
%   - name: name of the animation
%     (with this name it can be reused several times in the document)
%   - number: number of animation frames / files (n)
% the animation will be composed of files
% xxx0.pdf, xxx1.pdf ... xxx(n-1).pdf


\title{Finite State machines}

\author{Jim Hef{}feron}
\institute{
  University of Vermont\\[1ex]
  \texttt{hefferon.net}
}
\date{}

% This is only inserted into the PDF information catalog.
\subject{Automata}

\usepackage{catchfilebetweentags} % read text from background.tex
\newcommand{\catchfilefn}{../../automata/automata.tex}
% Keep from swallowing end-of-lines
%   https://tex.stackexchange.com/a/40704/121234
\usepackage{etoolbox}
\makeatletter
\patchcmd{\CatchFBT@Fin@l}{\endlinechar\m@ne}{}
  {}{\typeout{Unsuccessful patch!}}
\makeatother

\usepackage{xr}
  % \externaldocument{../../book}
  \externaldocument{../../automata/automata}
\usepackage{cleveref}

% Directory of this chapter's asy material
\newcommand{\asydir}{../../automata/asy/}
% \newcommand{\tmexercises}{\asydir tm_exercises/pdfs/}
% Directory of the src/asy material
\newcommand{\generalasydir}{../../asy/}

% \usepackage{multirow,bigstrut}
\begin{document}
\begin{frame}
  \titlepage
\end{frame}




\section{Finite State machines}
% ------------------------------------------------------
\begin{frame}
  \frametitle{Motivation}

Turing and other researchers tried to define what is computable in principle.
Church's Thesis is that their definitions do indeed capture the intuitive 
idea of effectively computable, of computable by an unbounded mechanism.

A person could object,
``Although a Turing machine has only finitely many states, it can write to
the tape.
Consequently there are Turing machines that write arbitrarily many times
to the tape, and so have unboundedly many configurations.
But the physical universe cannot support unboundedly many configurations.''

We will next study machines that are modifications of Turing machines
to have a bounded number of configurations.
These have finitely many states and can read,
but they cannot write.
Instead, they just consume their input and then indicate either that the 
input string was accepted or that it was not accepted. 
\end{frame}



\begin{frame}
  \frametitle{Definitions}
\ExecuteMetaData[\catchfilefn]{def:FSM}

\begin{center}
  \includegraphics{\generalasydir share/machine02.pdf}
\end{center}

\pause{\color{blue}\textit{Remark:}}
Recall that Turing machines are defined to be
sets of four-tuple instructions  $q_pT_pT_nq_n$,
subject to the restriction that the set is
deterministic, that no two instructions can begin with 
the same pair $q_pT_p$.
Consequently, over all $q_pT_pT_nq_n\in\TM$
the association of present pair $q_pT_p$ with next pair~$T_nq_n$,
defines a function, the next-state function
$\map{\Delta}{Q\times \Sigma}{\Sigma\cup\set{\str{L},\str{R}}\times Q}$.  

Finite State machines work the same way, 
and in the definition above 
we skipped four-tuples and went straight to the function.
\end{frame}


\begin{frame}
\begin{example}
This machine has input alphabet 
$\Sigma=\B=\set{\str{0},\str{1}}$.
The set of states is $Q=\set{q_0,q_1,q_2}$.
It has one accepting state $F=\set{q_2}$, marked in the diagram with
a double circle.
\begin{center}
  \includegraphics{asy/fsm00.pdf}
\end{center}
The transition function is a tabular version of the diagram.
For instance, $\Delta(q_1,\str{1})=q_2$.
\begin{center}
\begin{transitionfunction}
      &\str{0}    &\str{1}   \\
    \cline{2-3}
    $q_0$ &$q_0$ &$q_1$   \\
    $q_1$ &$q_1$ &$q_2$    \\
    \acceptingstate
    $q_2$ &$q_2$ &$q_2$  \\
\end{transitionfunction}
\end{center}
The $\acceptingstatemark$ next to $q_2$ marks
it as an accepting state.

This machine accepts the string \str{01010}.
It does not accept the string \str{001}.
In general, it accepts strings that contain at least two \str{1}'s.
\end{example}
\end{frame}


\begin{frame}
\begin{example}
\ExecuteMetaData[\catchfilefn]{ex:FSAValidIntegers}
\begin{center}  \small
  \vcenteredhbox{\includegraphics{\asydir fsa/fsa07.pdf}}
  \hspace{3em}
  \begin{transitionfunction}
      &\str{+}, \str{-} &\str{0}, \ldots{} \str{9} &\tabulartext{other}   \\
    \cline{2-4}
    $q_0$ &$q_1$ &$q_2$ &$e$   \\
    $q_1$ &$e$   &$q_2$ &$e$   \\
    \acceptingstate $q_2$ &$e$   &$q_2$ &$e$   \\
    $e$   &$e$   &$e$   &$e$   \\
  \end{transitionfunction}
  \end{center}
\end{example}
\pause
\begin{example}
This machine accepts only the single string \str{HEF}.
\begin{center}
  \includegraphics{asy/fsm01.pdf}
\end{center}
\end{example}
\end{frame}


\begin{frame}
\begin{example}
This machine accepts only strings where \str{HEF} is the prefix.
\begin{center}
  \includegraphics{asy/fsm02.pdf}
\end{center}
\end{example}
\pause
\begin{example}
This machine accepts only strings where \str{HEF} is the suffix.
\begin{center}
  \includegraphics{asy/fsm03.pdf}
\end{center}
\end{example}
\end{frame}




\begin{frame}
\begin{example}
This machine accepts only strings where \str{HEF} is a substring.
\begin{center}
  \includegraphics{asy/fsm04.pdf}
\end{center}
\end{example}
\pause
\begin{example}
This machine accepts only strings consisting of
zero or more repetitions of \str{HEF}.
\begin{center}
  \includegraphics{asy/fsm05.pdf}
\end{center}
The string consisting of zero-many repetitions of \str{HEF} is the
empty string,~$\emptystring$. 
\end{example}
\end{frame}




\begin{frame}
\begin{example}
This machine accepts all strings starting with zero or more 
copies of \str{HEF}.
\begin{center}
  \includegraphics{asy/fsm06.pdf}
\end{center}
(It is a gotcha question; all strings begin with zero-many copies of \str{HEF}.)
\end{example}
\pause
\begin{example}
This machine accepts only the strings \str{CAT} or \str{DOG}.
\begin{center}
  \includegraphics{asy/fsm07.pdf}
\end{center}
\end{example}
\end{frame}


\begin{frame}
\begin{example}
This machine, with input alphabet $\sigma=\set{\str{a},\str{b}}$,
accepts only strings with an even number of \str{a}'s.
\begin{center}
  \includegraphics{asy/fsm08.pdf}
\end{center}
\end{example}
\pause
\begin{example}
This machine, with the same alphabet, 
accepts strings with at least three \str{a}'s.
\begin{center}
  \includegraphics{asy/fsm09.pdf}
\end{center}
\end{example}
\end{frame}



% \begin{frame}{Configurations}
% \ExecuteMetaData[\catchfilefn]{discussion:FSMConfiguration}
% \end{frame}

\begin{frame}{The action of a Finite State machine}
As with Turing machines, we can give a definition
of how Finite State machines act that is mathematically precise.
A \definend{configuration} of a Finite State machine $\FSM$ is 
a pair $\mathcal{C}=\sequence{q,\tau}$, with
$q\in Q$ and $\tau\in\kleenestar{\Sigma}\!$.
Where $\mathcal{C}_0=\sequence{q_0,\tau_0}$ is the
\definend{initial configuration},
$\tau_0$ is the \definend{input}.

\begin{example}
We can trace through this machine when given the input $\tau_0=\str{abababb}$.
\begin{center}
  \includegraphics{asy/fsm09.pdf}
\end{center}
The transition function~$\Delta$ determines how
the machine moves step-by-step,
in response to the input (read `$\yields$' aloud as ``yields'').
\begin{align*}
    \mathcal{C}_0=\sequence{q_0,\str{abababb}}
    &\yields \mathcal{C}_1=\sequence{q_1,\str{bababb}}  \\
    &\yields \mathcal{C}_2= \sequence{q_1,\str{ababb}}  \\
    &\yields \mathcal{C}_3= \sequence{q_2,\str{babb}}  \\
    &\yields \mathcal{C}_4 = \sequence{q_2,\str{abb}}   \\
    &\yields \mathcal{C}_5 = \sequence{q_3,\str{bb}}  \\
    &\yields \mathcal{C}_6 = \sequence{q_3,\str{b}}  \\
    &\yields \mathcal{C}_7=  \sequence{q_3,\emptystring}
\end{align*}
The machine accepts $\tau_0$ because when $\tau=\emptystring$ 
then the state~$q_3$ is accepting.
\end{example}
\end{frame}



\begin{frame}{Language of a machine}
\ExecuteMetaData[\catchfilefn]{def:FSMLanguage}

\begin{example}
This machine
\begin{center}
  \includegraphics{asy/fsm07.pdf}
\end{center}
has the language
$\lang(M)=\set{\str{CAT},\str{DOG}}$.
\end{example}
\end{frame}

\begin{frame}
\begin{example}
This machine 
\begin{center}
  \includegraphics{asy/fsm05.pdf}
\end{center}
has the language
$\lang=\set{\emptystring,\str{HEF}, \str{HEFHEF}, (\str{HEF})^3,\ldots}$.
\end{example}

\begin{example}
This machine recognizes a natural number
that is a multiple of three, such as \str{15} or~\str{5013}.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir fsa/fsa12.pdf}}
\end{center}
Where $\Sigma=\set{\str{0}, \ldots{}\str{9}}$, 
the language is this.
\begin{equation*}
  \lang(\FSM)=\set{\sigma\in\kleenestar{\Sigma}
    \suchthat\text{$\sigma$ is the decimal representation of a multiple of three}}
\end{equation*}
\end{example}
\end{frame}

\renewcommand{\schemeautomata}{../../scheme/automata/}
\begin{frame}[fragile]{Finite State machines translate easily to code}
\vspace*{-1ex}
Here is a Racket implementation of the above multiple of three machine.
\lstinputlisting[firstline=31,lastline=47]{\schemeautomata mod3-fsm.rkt}
The \codeinline{(memv ch list)} command determines whether
\codeinline{ch} is a member of the list.
% \begin{lstlisting}
% def multiple_of_three_fsm(s):
%     state = 0
%     for ch in s:
%         if state == 0:
%             if ch in set([0,3,6,9]):
%                 state = 0
%             elif ch in set([1,4,7]):
%                 state = 1
%             else:
%                 state = 2
%         elif state == 1:
%             if ch in set([0,3,6,9]):
%                 state = 1
%             elif ch in set([1,4,7]):
%                 state = 2
%             else:
%                 state = 0
%         else:
%             if ch in set([0,3,6,9]):
%                 state = 2
%             elif ch in set([1,4,7]):
%                 state = 0
%             else:
%                 state = 1
%     if state == 0:
%         return True
%     else:
%         return False      
% \end{lstlisting}
\end{frame}

\begin{frame}{Extended transition function}
\ExecuteMetaData[\catchfilefn]{def:ExtendedTransitionFcn}

\begin{example}
For this machine, compute the extended transition function 
on all strings of length less than three.
\begin{center}
  \includegraphics{asy/fsm09.pdf}
\end{center}
The alphabet $\Sigma=\set{\str{a},\str{b}}$ has two elements so
there are seven strings of length less than three.
\begin{center}
\begin{tabular}{r|*{7}{c}}
  \tabulartext{Input $\sigma$}
    &$\emptystring$ &\str{a} &\str{b} &\str{aa} &\str{ab} &\str{ba} &\str{bb} \\
  \cline{2-8}
  \tabulartext{$\hat{\Delta}(\sigma)$}
    &$q_0$          &$q_1$   &$q_0$   &$q_2$    &$q_1$    &$q_1$    &$q_0$
\end{tabular}
\end{center}
\end{example}
\end{frame}







% ===========================================
\section{Nondeterminism}
\begin{frame}{Recall: determinism} 
The Turing machine definition gives that the
set of instructions  $q_pT_pT_nq_n$
must be deterministic, meaning  
that no two instructions can begin with the same pair $q_pT_p$.
For instance the definition outlaws that both $q_0\str{10}q_1$
and  $q_0\str{11}q_2$ are in the same machine because they both
start with $q_0\str{1}$.

Consequently, over the four-tuples $q_pT_pT_nq_n$ in a machine,
the association of present pair $q_pT_p$ with next pair $T_nq_n$
defines a function, the next-state function.
\begin{equation*}
\map{\Delta}{Q\times \Sigma}{\Sigma\cup\set{\str{L},\str{R}}\times Q}
\end{equation*}
It is this function that 
governs the sequence of transitions
from configuration to configuration.

Finite State machines work the same way. 
The definition gives them as also deterministic.

\pause\medskip
We now drop determinism.
We will 
do it here for Finite State machines and in the next chapter
for Turing machines.

Nondeterminism is very important.
But it
can give the initial impression of being unnatural.
So before the definition
we will see two examples of computations that, in some sense,
do more than one thing at a time.
These will lead to two mental models, which we will rely on for the
rest of the course.
\end{frame}


\begin{frame}{Nondeterminism: deriving a string from a grammar}
From this grammar
\begin{grammar}
  S \produces{} T\trm{b}U

  T \produces{} \trm{a}T \syntaxor \emptystring{}

  U \produces{} \trm{a}U \syntaxor \trm{b}U \syntaxor \emptystring{}  
\end{grammar}
we can derive, for example, $\sigma_0=\str{aabab}$
  \begin{center}
  \begin{tabular}{l}
    S \derives T \trm{b} U
    \derives \trm{a} T \trm{b} U    
    \derives \trm{a} \trm{a} T \trm{b} U    
    \derives \trm{a} \trm{a} \emptystring{} \trm{b} U
       =\trm{a} \trm{a} \trm{b} U    
    \\ \quad 
    \derives \trm{a} \trm{a} \trm{b} \trm{a} U
    \derives \trm{a} \trm{a} \trm{b} \trm{a} \trm{b} U
    \derives \trm{a} \trm{a} \trm{b} \trm{a} \trm{b} \emptystring{}
    =\trm{a} \trm{a} \trm{b} \trm{a} \trm{b}
  \end{tabular}
  \end{center}
or $\sigma_1=\str{baab}$.
\begin{center}
  \begin{tabular}[t]{l}
    S\derives  T \trm{b} U
    \derives \emptystring{} \trm{b} U
      = \trm{b} U    
    \derives \trm{b} \trm{a} U 
    \\ \quad 
    \derives \trm{b} \trm{a} \trm{a} U 
    \derives \trm{b} \trm{a} \trm{a} \trm{b} U 
    \derives  \trm{b} \trm{a} \trm{a} \trm{b} \emptystring{}  
    =  
    \trm{b} \trm{a} \trm{a} \trm{b} 
  \end{tabular}
\end{center}
Derivation is a computation in that it is pushing symbols by following
rigid rules.

\pause
This computation is nondeterministic in the sense that while doing 
a sequence of $\derives$~steps,
we often find that more than one $\rightarrow$~rule applies.
So there is more than one next thing to do, not just a unique next string.
\end{frame}


% to get all three images to line up I need to know the width of the largest
\newsavebox\jhimagebox %
\sbox{\jhimagebox}{%
  \includegraphics{asy/nfsm19.pdf}%
}% 
\setlength{\unitlength}{\wd\jhimagebox}
\begin{frame}
  % \frametitle{Finding a derivation}
Suppose that we have a grammar where there is sometimes more than one
applicable rule.
Give a target string~$\sigma$, how to derive it?

One way is brute force:~perform
all applicable production rules to the start symbol, 
then for each result perform all applicable rules,
etc. 
If $\sigma$ is in the language of the grammar then we will 
eventually derive it.
This is a breadth-first search of the $\derives\!$~sequences;
here are the first few levels for the grammar on the prior slide.
% The width is \the\wd\jhimagebox.
% The height is \the\ht\jhimagebox.
% The width is 325.72612pt. The height is 110.4624pt.
% I by-hand calculated that 110.4624÷325.72612 = 0.339126626
\begin{center}\small
  \begin{picture}(1,0.339126626)
    \only<1>{\put(0.558,0.249){\includegraphics{asy/nfsm17.pdf}}}%
    \only<2>{\put(0.124,0.187){\includegraphics{asy/nfsm18.pdf}}}%
    \only<3-4>{\put(0,0){\includegraphics{asy/nfsm19.pdf}}}%
  \end{picture}
\end{center}
\only<4>{The second way, 
the way that we actually solve these problems such as the ones in the Grammar
section's homework, is to guess.
We look at the derivation rules and
think, ``Well I wonder if it might have to do with \ldots{}''\sentencespace 
Of course, then we must verify the guess by exhibiting a derivation.}
\end{frame}


\begin{frame}{Nondeterminism: a machine}\vspace*{-1ex}
This machine is nondeterministic: for a given pair
$\sequence{\textrm{present state}, \textrm{input character}}$ 
there may be one next state, or more than one, or none.
For instance, leaving $q_0$ are two different arrows labeled~\str{0}.
And there is no arrow at all leaving $q_1$ with the label~\str{1}.
\begin{center}\small
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm00.pdf}}
\end{center}
Suppose that this machine gets the input~\str{00001}.
Just as with the grammar, we will have two ways to think of what happens.
First, we can trace out every possible branch.
\end{frame}
\begin{frame}
\begin{center}\small
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm00.pdf}}
\end{center}
% The input is~\str{00001}.
\begin{center}\small
  \only<1>{\includegraphics{\asydir nfsm/nfsm02.pdf}}%
  \only<2>{\includegraphics{\asydir nfsm/nfsm03.pdf}}%
  \only<3>{\includegraphics{\asydir nfsm/nfsm04.pdf}}%
  \only<4>{\includegraphics{\asydir nfsm/nfsm05.pdf}}%
  \only<5>{\includegraphics{\asydir nfsm/nfsm06.pdf}}%
  \only<6>{\includegraphics{\asydir nfsm/nfsm07.pdf}}%
  \only<7>{\includegraphics{\asydir nfsm/nfsm08.pdf}}% using onslide causes other figs to not be centered
\end{center}
% \begin{center}\small
%   \only<1>{\includegraphics{asy/nfsm02.pdf}}%
%   \only<2>{\includegraphics{asy/nfsm03.pdf}}%
%   \only<3>{\includegraphics{asy/nfsm04.pdf}}%
%   \only<4>{\includegraphics{asy/nfsm05.pdf}}%
%   \only<5>{\includegraphics{asy/nfsm06.pdf}}%
%   \only<6>{\includegraphics{asy/nfsm07.pdf}}%
%   \only<7>{\includegraphics{asy/nfsm08.pdf}}% using onslide causes other figs to not be centered
% \end{center}
\only<7>{The highlighted branch ends in an accepting state.}
\end{frame}

\begin{frame}
As with the grammar,
we are picturing that when the machine is asked to do two things, 
it does them both.
And when there is no next state, the branch dies.
So the computation history is not straight-line but instead is a tree.

After the first step, the machine is in multiple states simultaneously, namely 
$q_0$ and~$q_1$.
The same also happens at all later steps; in all of those steps
the machine is in a set of states.

There is a branch that gets to the end and accepts the 
input string~\str{00001}.
Branches can fail to accept the string because they die,  
or because they get to the end and they just are not in an accepting state.

\pause
As with the grammar, 
there is a second way to think of what is happening. 
This machine,
\begin{center}\small
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm00.pdf}}
\end{center}
when presented with an input string~\str{00001}, must decide:~when 
should it stop going around $q_0$'s loop 
and start following the tail to the right?
Above we've seen the machine accepting \str{00001},
so it has solved this problem.
We could say that the machine has correctly guessed.
\end{frame}




\begin{frame}{First mental model for nondeterminism: spawning}
For the grammar example, we made a branch each time a
production rule applied to a string.
For the machine example, we also branched each time there was a
possible thing to do.

Another example of this branching is 
the Travelling Salesman problem.
Suppose that we want a cyclic trip 
that visits every state capitol in the forty eight contiguous US~states
in less than $16\,000$ kilometers.
If we start at Montpelier, Vermont 
then there are forty seven possible next cities. 
A reasonable approach is to spawn forty seven child processes.
The process assigned Albany, 
for instance, would know that the trip so far is $126$~kilometers. 
After that, each child would fork its own set of children, forty six of them.
At the end if there is
a trip of less than $16\,000$ kilometers then some branch has found it.
Note that we consider
the overall computation a success if there exists 
even one process that is a success.

The first mental model for nondeterminism is that when presented with 
multiple things to do, the machine does them all.
Think of it as an unboundedly parallelizable device.

This model 
is natural.
In everyday computing, we are all used to having lots of windows open 
on the screen, doing lots of things.
Under the hood, the operating system forks child processes to cover each
thing that it must do.
\end{frame}


\begin{frame}{Second mental model for nondeterminism: guessing}
For both the grammar example and the machine example, we have also framed
that the system guessed the answer.

For example, we described the nondeterministic machine as guessing when 
to stop going around $q_0$'s loop
and start following the tail to the right.

\pause
Saying ``guessing'' is jarring because 
our experience with computers in programming class is that
they don't guess.
An alternate way to state this model is that the machine is
furnished with the answer (``go around twice, then off to the right'') and
it only has to verify that answer.
Often the furnisher is personified as a demon.
\begin{center}\small
  \vcenteredhbox{\includegraphics[height=1.25in]{../../automata/pix/flauros.jpg}}
  \\
  \mbox{Flauros, the Duke of Hell.}
\end{center}
\end{frame}

\begin{frame}{What the two views share}
In both mental models, the computation succeeds if there is a way for it 
to succeed.
More precisely, 
the machine accepts the input if there exists a sequence of configurations
that ends in an accepting state.

Very important: `if there exists' doesn't mean that there must be an algorithm
for finding it such as backtracking or dynamic programming, etc.
This is pure existence\Dash it just requires that there 
is a way for the computation to succeed.
That's why the demon is here;~it is so powerful that it 
goes beyond needing ordinary computation to get the
answer.
\end{frame}


\begin{frame}
\frametitle{Definition of a Nondeterministic Finite State machine}

To make the definition of a nondeterministic Finite State machine,
we change one thing from the definition of Finite State machine,
namely we change the codomain of $\Delta$ from 
$Q$ to the power set $\powerset(Q)$.

\ExecuteMetaData[\catchfilefn]{def:NondeterministicFiniteStateMachine}
\ExecuteMetaData[\catchfilefn]{def:NFSMAccepted}

The machine accepts its input if there 
exists at least one sequence of configurations that ends
in acceptance.

\begin{example}
This nondeterministic
listener waits to hear the remote signal
\str{0101110}.
That is, it accepts the language
$\set{\sigma\concat\str{0101110}\suchthat \sigma\in\kleenestar{\B}}$.
\begin{center}
  \includegraphics{\asydir nfsm/nfsm11.pdf}
\end{center}
For example, if this listener 
hears a string $\sigma=\str{010101110}$, with three \str{01}'s in the prefix
instead of two then it ends in an accepting 
state.
In terms of our second framing, it guesses that it should ignore
the first \str{01} but not the second.
\end{example}
\end{frame}

\begin{frame}
  \frametitle{Nondeterminism can simplify thinking about machines}
\begin{example}
This nondeterministic Finite State machine 
accepts only those strings ending in \str{HEF}.
(The alphabet~$\Sigma$ is the capital ASCII letters.)
\begin{center}
  \includegraphics{asy/nfsm11.pdf}
\end{center}

\pause
Contrast that with what we got when we did this job
using a deterministic machine.
\begin{center}
  \includegraphics{asy/fsm03.pdf}
\end{center}
The nondeterministic machine is easier to understand and
more obviously matches its specification.
\end{example}
\end{frame}


\begin{frame}
\begin{example}
This nondeterminstic Finite State machine~$\FSM$  
with alphabet $\Sigma=\set{\str{a},\str{b}}$
accepts an input string only
if it has \str{a} in the third position from the end.
\begin{center}
  \includegraphics{asy/nfsm09.pdf}
\end{center}
Thus 
$\lang(\FSM)=\set{\str{aaa}, \str{aab}, \str{aba}, \str{abb},\str{aaaa}, \str{aaab},\str{aaba},\str{aabb},\str{baaa},\str{baab},\ldots}$.
\end{example}

\pause
\begin{example}
This nondeterministic machine~$\hat{\FSM}$ 
with alphabet $\Sigma=\set{\str{0},\str{1}}$ 
accepts an input string only
if it contains a substring
with a \str{1} followed by any number of \str{0}'s,
including possibly zero-many \str{0}'s, 
followed by a second \str{1}.
\begin{center}
  \includegraphics{asy/nfsm16.pdf}
\end{center}
Thus 
$\lang(\hat{\FSM})=\set{\str{11}, \str{011}, \str{110}, \str{111},\str{0011}, \str{0101},\str{0110},\str{0111},\ldots}$.
\end{example}
\end{frame}

\begin{frame}{$\varepsilon$ transitions}
\ExecuteMetaData[\catchfilefn]{discussion:epsilonTransitions}

\pause
\begin{example}
\hypertarget{ex:EpsilonTransitionsForConcat}{The machine on the left} 
accepts strings with 
prefix \str{ab}.
The one on the right accepts strings with suffix \str{ab}.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/nfsm12.pdf}}
  \hspace{4em}
  \vcenteredhbox{\includegraphics{asy/nfsm13.pdf}}
\end{center}
This $\varepsilon$ transition joins them together, serially.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/nfsm14.pdf}}
\end{center}
\end{example}
The joined machine accepts strings that begin with 
\str{ab} and end with \str{ab}.
\end{frame}


\begin{frame}
\begin{example} 
\hypertarget{ex:EpsilonTransitionsForOr}{We can take} the same two machines, 
one that accepts strings with 
prefix \str{ab} and
one that accepts strings with suffix \str{ab}.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/nfsm12.pdf}}
  \hspace{4em}
  \vcenteredhbox{\includegraphics{asy/nfsm13.pdf}}
\end{center}
and join them in parallel.
The result accepts strings that begin with \str{ab} 
or end with \str{ab}.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/nfsm15.pdf}}
\end{center}
\end{example}

\pause
\ExecuteMetaData[\catchfilefn]{ex:EpsilonGivesKleeneStar}
\end{frame}


\begin{frame}
\begin{example}
For this nondeterministic
Finite State machine with $\varepsilon$ transitions
\begin{center}
    \includegraphics{\asydir nfsm/nfsm1044.pdf}
\end{center}
the computation tree on input \str{aab} is below.
The $\varepsilon$ moves are shown vertically, within the white stripes.
\begin{center}
    \includegraphics{\asydir nfsm/nfsm1049.pdf}
\end{center}
There is an accepting branch, highlighted.    
\end{example}
\end{frame}


\begin{frame}{$\varepsilon$ Closure}

\ExecuteMetaData[\catchfilefn]{df:EpsilonClosurei}

\begin{example}
For this machine,
these are the $\varepsilon$~closures.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm93.pdf}}
  \quad
  \begin{tabular}{r|*{4}{c}}
  \tabulartext{state}
     &$q_0$           &$q_1$          &$q_2$        &$q_3$  
  \\ \cline{2-5}
  \tabulartext{$\varepsilon$ closure}
     &$\set{q_0,q_1}$ &$\set{q_1}$ &$\set{q_1,q_2,q_3}$ &$\set{q_1,q_3}$ 
\end{tabular}
\end{center}
\end{example}
\end{frame}


\begin{frame}
\begin{example}
We can compute a state's $\varepsilon$~closure by proceeding in steps.
The table below uses this machine.
\begin{center}
  \includegraphics{\asydir nfsm/nfsm83.pdf}
\end{center}
\ExecuteMetaData[\catchfilefn]{df:EpsilonClosureii}
\end{example}
\end{frame}

\begin{frame}{The action of a nondeterministic Finite State machine with $\varepsilon$ moves}
% \ExecuteMetaData[\catchfilefn]{disc:EpsilonClosurei}

\ExecuteMetaData[\catchfilefn]{disc:EpsilonClosureii}
\end{frame}
\begin{frame}
\ExecuteMetaData[\catchfilefn]{disc:EpsilonClosureiii}
\end{frame}




\begin{frame}{Equivalence of machine types}
We will show how to convert any nondeterministic Finite State
machine into a deterministic machine doing the same job.
% So we can think of nondeterminism
% as an abbreviation for determinism.
This may help obviate qualms over `guessing'.

\ExecuteMetaData[\catchfilefn]{th:dfsmEquivndfsm}

\ExecuteMetaData[\catchfilefn]{pf:dfsmEquivndfsm}
\end{frame}


\begin{frame}
\begin{example}
Here is a nondeterministic Finite State machine~$\FSM$.
\begin{center}
  \includegraphics{asy/nfsm20.pdf}
\end{center}
The equivalent deterministic machine's states are the sets of $\FSM$'s states.
The starting state is $s_1=\set{q_0}$.
A state is accepting if it contains any accepting state of the 
nondeterministic machine.
\begin{center}\small
\begin{tabular}{r|cc}
  \multicolumn{1}{c}{\ } &\str{0} &\str{1}  \\
  \cline{2-3}
  $s_0=\set{}$            &$s_0$ &$s_0$  \\
  $s_1=\set{q_0}$         &$s_1$ &$s_4$  \\
  $s_2=\set{q_1}$         &$s_0$ &$s_5$  \\
  \acceptingstate
  $s_3=\set{q_2}$         &$s_3$ &$s_0$  \\
  $s_4=\set{q_0,q_1}$     &$s_1$ &$s_7$  \\
  \acceptingstate
  $s_5=\set{q_0,q_2}$     &$s_5$ &$s_4$  \\
  \acceptingstate
  $s_6=\set{q_1,q_2}$     &$s_3$ &$s_5$  \\
  \acceptingstate
  $s_7=\set{q_0,q_1,q_2}$ &$s_5$ &$s_7$  \\
\end{tabular}     
  \qquad
  \vcenteredhbox{\includegraphics{asy/fsm10.pdf}}
\end{center}
\end{example}
\end{frame}


\begin{frame}
Here is that diagram again, along with the one showing
only reachable states.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/fsm10.pdf}}  \\[2ex]
  \vcenteredhbox{\includegraphics{asy/fsm11.pdf}}
\end{center}
\end{frame}




\begin{frame}{Algorithm for converting to a deterministic machine}
\ExecuteMetaData[\catchfilefn]{df:DFSMFromNFSM}

\pause\medskip
As an example, the next slide does the conversion for this machine.
\begin{center}\small
  $\FSM_N$:\qquad\vcenteredhbox{\includegraphics{\asydir nfsm/nfsm93.pdf}} 
\end{center}
\end{frame}

\begin{frame}
\begin{center}\small
  $\FSM_N$:\qquad\vcenteredhbox{\includegraphics{\asydir nfsm/nfsm93.pdf}} 
\end{center}
The start state is $\hat{E}(\set{q_0})=s_7$.
A state of $\FSM_D$ is accepting if and only if it contains $q_1$.
\ExecuteMetaData[\catchfilefn]{ex:DFSMFromNFSMWithEpsilon}

\end{frame}

\begin{frame}
Here is that deterministic machine as a graph,
showing only the reachable states.
\begin{center}
  \includegraphics{\asydir nfsm/nfsm1043.pdf}
\end{center}
\end{frame}








% =======================================================
\section{Regular expressions}

\begin{frame}{Examples}
The languages accepted by a Finite State machine have patterns.
We exploit these patterns to describe them with \alert{regular expressions}.
We will start with some examples and then give a definition.

\ExecuteMetaData[\catchfilefn]{ex:RegexOne}

\pause
Those strings are accepted by this Finite State machine.
\begin{center}
  \includegraphics{asy/nfsm22.pdf}
\end{center}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:RegexTwo}

\pause
That is the language of this machine.
\begin{center}
  \includegraphics{asy/nfsm23.pdf}
\end{center}

\begin{example}
The strings that are accepted by this machine match \re{a*ba*}.
\begin{center}
  \includegraphics{\asydir fsa/fsa14.pdf}
\end{center}
\end{example}
\end{frame}


\begin{frame}{Definition: syntax}
\begin{definition}
\ExecuteMetaData[\catchfilefn]{def:RESyntax}
\end{definition}
\end{frame}

\begin{frame}{Semantics}
\ExecuteMetaData[\catchfilefn]{discussion:RESemantics}
\end{frame}


\begin{frame}{Examples}
\ExecuteMetaData[\catchfilefn]{ex:RegexThree}
\pause
\ExecuteMetaData[\catchfilefn]{ex:RegexFour}
\pause
\begin{example}
\ExecuteMetaData[\catchfilefn]{ex:RegexFive}
\end{example}
\pause
\ExecuteMetaData[\catchfilefn]{ex:RegexSix}
\end{frame}


\begin{frame}{More examples}

\begin{example}
Produce a regular expression to match each description.
For each, take the alphabet to be the set of bits,~$\B=\set{\str{0},\str{1}}$.
\begin{enumerate}
\item
The set of bitstrings that end in three consecutive \str{1}'s. 
\pause
\item
The set of bitstrings with at least one~\str{0}.
\pause
\item The bitstrings containing at least three~\str{1}'s.
\pause
\item The set of bitstrings starting with a digit other than the one
that it ends with.
\end{enumerate}
\end{example}

% \begin{example}
% Produce a regular expression for each.
% Take the alphabet to be the lower-case ASCII letters.
% Use \url{http://joshua.smcvt.edu/cgi-bin/test_regex.py}.
% (1)~Words containing both an \str{e} and a \str{u}.
% \pause
% (2)~Words having \str{f} as the second letter.
% \pause
% (3)~How many words start in \str{th}?
% \pause
% (4)~Words starting with \str{w} and containing a \str{y}.
% \end{example}
\end{frame}
% import re
% import sys

% file = open(sys.argv[2], "r")

% for line in file:
%      if re.search(sys.argv[1], line):
%          print line,

\begin{frame}{Kleene's Theorem}
\ExecuteMetaData[\catchfilefn]{th:KleenesTheorem}

\pause
\ExecuteMetaData[\catchfilefn]{lem:KleenesThmRegexToMachine}

\proofname\hspace{0.6em} 
We will show that for any regular expression~$R$ there is a machine that
accepts strings matching that expression.
We give nondeterministic machines, but of course we can convert them
to deterministic ones if desired.

\ExecuteMetaData[\catchfilefn]{pf:KleenesThmRegexToMachinei}
  \begin{center}
    \hspace*{8em}
    \includegraphics{\asydir nfsm/nfsm32.pdf}
    \hspace{2em plus 1fill}
    \includegraphics{\asydir nfsm/nfsm33.pdf}
    \hspace{2em plus 1fill}
    \includegraphics{\asydir nfsm/nfsm34.pdf}
    \hspace*{8em}
  \end{center}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{pf:KleenesThmRegexToMachineiia}
For example, this shows two machines combined
\begin{center}
  \includegraphics{\asydir nfsm/nfsm14.pdf}
\end{center}
The top nondeterministic machine's language is
$\set{\sigma\in\kleenestar{\Sigma}\suchthat \text{$\sigma$ ends in \str{ab}}}$
and the bottom machine's language is
$\set{\sigma\in\kleenestar{\Sigma}\suchthat \text{$\sigma=(\str{ac})^n$ for some $n\in\N$}}$.
The language for the entire machine is the union.
\begin{equation*}
  \lang=\set{\sigma\in\kleenestar{\Sigma}\suchthat
   \text{either $\sigma$ ends in \str{ab} or $\sigma=(\str{ac})^n$ for $n\in\N$}}
\end{equation*}
%See \hyperlink{ex:EpsilonTransitionsForOr}{this earlier example of parallel machines}.
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{pf:KleenesThmRegexToMachineiib}
For example, the machine on the left below recognizes the language
of repetitions of the string \str{aab}, 
$\lang_0=\set{(\str{aab})^i\suchthat i\in\N}$.
The machine on the right recognizes repetitions of either \str{a}
or \str{aba},
$\lang_1=\set{\sigma_0\concat\cdots\,\sigma_{j-1}\suchthat \text{$j\in\N$ and $\sigma_k=\str{a}$ or $\sigma_k=\str{aba}$ for $0\leq k\leq j-1$}}$.
\begin{center} % align graphics on top https://tex.stackexchange.com/a/126919/121234
  % Get width of first graphic
  \newsavebox{\jhtmpboxautomatai}
  \savebox{\jhtmpboxautomatai}{\includegraphics{\asydir nfsm/nfsm89.pdf}}
  \newlength{\jhtmplengthautomatai}
  \settowidth{\jhtmplengthautomatai}{\usebox{\jhtmpboxautomatai}}
  % Get width of second graphic
  \newsavebox{\jhtmpboxautomataii}
  \savebox{\jhtmpboxautomataii}{\includegraphics{\asydir nfsm/nfsm90.pdf}}
  \newlength{\jhtmplengthautomataii}
  \settowidth{\jhtmplengthautomataii}{\usebox{\jhtmpboxautomataii}}
  % Tabulars align paragraphs on top
  \begin{tabular}{p{\jhtmplengthautomatai} @{\hspace*{3em}} p{\jhtmplengthautomatai}}
    \vspace{0pt} \usebox{\jhtmpboxautomatai}
    &\vspace{0pt} \usebox{\jhtmpboxautomataii}
  \end{tabular}
\end{center}
The 
combined machine accepts strings in the concatenation of those languages,
$\mathcal{L}(\FSM)=\lang_0\concat\lang_1$.
\begin{center}
  \includegraphics{\asydir nfsm/nfsm13.pdf}
\end{center}
then 
%See \hyperlink{ex:EpsilonTransitionsForConcat}{the example of machine concatenation}.
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{pf:KleenesThmRegexToMachineiic}
For example, without the $\varepsilon$~edge this machine's language is
$\set{\emptystring, \str{ab}}$,
while with it the language is  
$\set{(\str{ab})^n\suchthat n\in\N}$.
\begin{center}
  \includegraphics{\asydir nfsm/nfsm15.pdf}
\end{center}
% See \hyperlink{ex:EpsilonTransitionsForStar}{the example of machine starring}.
Those are all the allowed operations, and so that ends the proof.
\qedsymbol
\end{frame}



\begin{frame}
\ExecuteMetaData[\catchfilefn]{lem:KleenesThmMachineToRegex}

Here is the idea:~start with a Finite State machine and eliminate its states
one at a time, keeping the accepted language the same.
\begin{center}
\includegraphics{\asydir nfsm/nfsm35.pdf}
\hspace{2em}
\includegraphics{\asydir nfsm/nfsm36.pdf}
\end{center}
For this, we generalize the transition graphs to allow
edge labels that are regular expressions.

A bit more detail:~take \re{a}, \re{b}, \re{c}, and~\re{d} to be
regular expressions.
Start by introducing a new start state guaranteed to have
no incoming edges, $e$,
and a new final state guaranteed to be unique,~$f$.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm64.pdf}}
  \hspace{2em}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm65.pdf}}
\end{center}
Then eliminate $q_1$ as below.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm66.pdf}}
\end{center}
\end{frame}



\begin{frame}
The proof is in the book.
Here is an illustration. 
\begin{example}
Consider~$\FSM$ on the left.
Introduce $e$ and~$f$ to get $\hat{\FSM}$ on the right.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm48.pdf}}
  \hspace{2em}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm49.pdf}}
\end{center}
\pause
Start by eliminating $q_2$.
That gives this machine.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm50.pdf}}
\end{center}
\end{example}
\end{frame}
\begin{frame}
Next eliminate $q_1$.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm51.pdf}}    
\end{center}
\pause
Finally, eliminate $q_0$.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir nfsm/nfsm52.pdf}}    
\end{center}
That regular expression simplifies.
For instance, \re{a$\varepsilon$}=\re{a}.
The result is \re{(a(b|ab*b))*($\varepsilon$|a)}.
\end{frame}







% ==============================================
\section{Regular languages}

\begin{frame}{Definition}
\ExecuteMetaData[\catchfilefn]{def:RegularLangs}

\begin{example}
The set
$\set{\str{a}\str{b}^n\suchthat n\in\N}
  =\set{\str{a}, \str{ab}, \str{abb}\,\ldots}$ is a regular language.
Another language that is regular is any finite set of strings. 
\end{example}

\pause
In the proof of Kleene's Theorem, we saw that if two languages
are regular then their union is also regular.
We say that a structure is \definend{closed} under an operation if
performing that operation on its members always yields another member.

\ExecuteMetaData[\catchfilefn]{lem:RegLangsClosedUnderUnionConcatStar}
\begin{proof}
  In the first lemma for the proof of Kleene's Theorem
  we did the regular expression operations of pipe,
  concatenation, and Kleene star.
  Those correspond to set operations;
  for instance, if $R_0$ is a regular expression describing the language
  $\lang_0$, and $R_1$ describes $\lang_1$, then the regular expression
  $\re{$R_0$|$R_1$}$ describes $\lang_0\cup\lang_1$.
\end{proof}
\end{frame}

\begin{frame}{Product construction}
\ExecuteMetaData[\catchfilefn]{ex:RegLangsProductConsti}
\begin{center}
  \vcenteredhbox{\includegraphics{../../automata/asy/nfsm/nfsm91.pdf}}
  \qquad
  \vcenteredhbox{\includegraphics{../../automata/asy/nfsm/nfsm92.pdf}}
\end{center}
\ExecuteMetaData[\catchfilefn]{ex:RegLangsProductConstii}
\end{frame}


\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:RegLangsProductConstiii}
\end{frame}


\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:RegLangsProductConstiv}
\end{frame}


\begin{frame}
\ExecuteMetaData[\catchfilefn]{th:RegLangsClosedCompIntDiff}

\ExecuteMetaData[\catchfilefn]{pf:RegLangsClosedCompIntDiff}

\pause
\begin{example}
Let $\Sigma=\B=\set{\str{0},\str{1}}$.
We could show that the language
$\lang=\set{\sigma\str{1}\suchthat \sigma\in\kleenestar{\Sigma}}$
is regular by producing a Finite State machine to accept it,
or by giving a regular expression that describes it.
But we can also use closure.
That language is the concatenation $\lang=\lang_0\concat\lang_1$
of
$  \lang_0=\kleenestar{\Sigma}$
and
$  \lang_1=\set{\str{1}}$,
which are both clearly regular.
Regular languages are closed under concatenation, so $\lang$ is regular.
\end{example}
\end{frame}


\begin{frame}
\begin{example}
The language 
\begin{equation*}
\lang=\set{\sigma\in\kleenestar{\set{\str{a},\str{b},\str{c}}}
  \suchthat \text{$\sigma$ does not have the substring \str{acb}}}
\end{equation*}
it the complement of
$\setcomp{\lang}=\set{\sigma\in\kleenestar{\set{\str{a},\str{b},\str{c}}}
  \suchthat \text{$\sigma$ has the substring \str{acb}}}$.
The language $\setcomp{\lang}$ is regular because it is 
described by a regular expression,
\re{(a|b|c)*acb(a|b|c)*}.
\end{example}

\pause
\begin{example}
We can show that the language 
\begin{equation*}
\lang=\set{\sigma\in\kleenestar{\set{\str{a},\str{b}}}
  \suchthat \text{$\sigma$ contains both of the substrings \str{acb} and \str{cbc}}}
\end{equation*}
is regular by constructing a Finite State machine
for each substring or give regular expressions, and then cite that the regular
languages are closed under intersection.
(By the way, note that
the string $\sigma=\str{acbc}$ is a member of $\lang$.)
\end{example}
\end{frame}


% ========================================================
\section{Languages that are not regular}

\begin{frame}{Periodicity}
\ExecuteMetaData[\catchfilefn]{ex:FSMLoopingi}
\begin{center}
  \includegraphics{\asydir nfsm/nfsm58.pdf}
\end{center}
\ExecuteMetaData[\catchfilefn]{ex:FSMLoopingii}
\end{frame}

\begin{frame}{Pumping lemma}
\ExecuteMetaData[\catchfilefn]{th:PumpingLemma}

\proofname. %\hspace{0.6em}
\ExecuteMetaData[\catchfilefn]{pf:PumpingLemmai}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{pf:PumpingLemmaii}\qedsymbol\ 
\end{frame}

\begin{frame}
  % \frametitle{Using the Pumping Lemma}
Usually we use the Pumping Lemma to show that a language
is not regular.

\begin{example}
Show that this language over $\Sigma=\set{\str{a},\str{b}}$ is not regular:
$\lang=\set{\str{a}^n\str{b}\str{a}^n\suchthat n\in\N}$.

First, here are five members of $\lang$: \str{aba}, \str{aabaa}, \str{aaabaaa}, 
$\str{a}^5\str{b}\str{a}^5$, and \str{b}.
Five non-members are \str{aabaaa}, $\str{a}^5\str{b}\str{a}^4$,
\str{a}, \str{aa}, and $\str{a}\str{b}$.

The proof is by contradiction.
Suppose that $\lang$ is regular.
Then it has a pumping length, which we denote~$p$.
Consider the string $\sigma=\str{a}^pb\str{a}^p$.
Observe that $\sigma\in\lang$.

Because $\sizeof{\sigma}\geq p$, 
that string decomposes as 
$\sigma=\alpha\concat\beta\concat\gamma$, subject to the
three conditions.
\pause
Condition~(1) says that the initial two substrings together have length
no greater than the pumping length, $\sizeof{\alpha\beta}\leq p$.
Therefore, because the first $p$-many characters in $\sigma$ are all \str{a}'s,
we conclude that substring $\alpha$ and substring $\beta$ consist solely of
\str{a}'s.
\pause
Condition~(2) says that $\beta$ is not the empty string
and so $\beta$ consists of at least one \str{a}.
\pause
With that, consider condition~(3).
It says that all of the strings 
$\alpha\gamma$, $\alpha\beta^2\gamma$, $\alpha\beta^3\gamma$, etc., are members
of $\lang$.
We will find the contradiction in $\alpha\gamma$.
Compared with $\sigma$,
the string $\alpha\gamma$ has at least one fewer \str{a} before the \str{b}
(because it omits the string $\beta$), 
but the same number of \str{a}'s after the~\str{b}.
Therefore, $\alpha\gamma$ does not have the same number of \str{a}'s before the
\str{b} as after.
It is thus not a member of~$\lang$, 
which is a contradiction.   
\end{example}
\end{frame}


\begin{frame}
\begin{example}
Consider this language.
\begin{equation*}
  \lang=\set{\tau\concat\tau\suchthat \tau\in\kleenestar{\B}}
\end{equation*}
Name five members and five nonmembers.
Then use the Pumping Lemma to prove that it is not a regular language.

\pause
Five members are
\str{001001}, \str{11011101}, \str{00}, \str{1111}, and $\varepsilon$.
Five nonmembers are \str{000}, \str{1}, \str{0110}, \str{001000}, and 
\str{01}.

For the proof, assume that $\lang$ is regular. 
Then it has a pumping length, which we will denote~$p$.
Consider the string $\sigma=\str{0}^p\str{1}\str{0}^p\str{1}$.

It is a member of~$\lang$ and $\sizeof{\sigma}\geq p$ so it decomposes
into three substrings $\sigma=\alpha\beta\gamma$ in a way that satisfies
the three conditions.

Condition~(1) is that $\alpha$ and $\beta$ together have length
no greater than the pumping length, $\sizeof{\alpha\beta}\leq p$.
Because the first $p$-many characters in $\sigma$ are all \str{a}'s,
this means that substring $\alpha$ and substring $\beta$ consist solely of
\str{0}'s.
Condition~(2) says that $\beta$ is not empty,
and so $\beta$ consists of at least one \str{0}.
Condition~(3) says that the strings 
$\alpha\gamma$, $\alpha\beta^2\gamma$, $\alpha\beta^3\gamma$, etc., are members
of $\lang$.
But compared with $\sigma$,
the string $\alpha\beta^2\gamma$ has at least one more \str{0} before 
its first~\str{1}, 
but the same number of \str{0}'s before its second\str{1}.
Therefore, $\alpha\beta^2\gamma$ does not have the form $\tau\concat\tau$
and is not a member of~$\lang$.
That's a contradiction.   
    
\end{example}

\pause
\begin{example}
Show that each language over $\Sigma=\set{\str{a},\str{b}}$ is not regular.
\begin{enumerate}
\item $\set{\str{a}^n\str{b}^m\suchthat n=m+1}$
\item the set of palindromes
\end{enumerate}
\end{example}
\end{frame}




% ========================================================
\section{Pushdown machines}
\begin{frame}{Introduction}
\ExecuteMetaData[\catchfilefn]{discussion:StackIntroi}

\ExecuteMetaData[\catchfilefn]{discussion:StackIntroii}
\begin{center}
  \vcenteredhbox{\includegraphics[height=1.1in]{../../automata/pix/dishes.jpg}}
  \hspace{4em}
  \vcenteredhbox{\includegraphics{\asydir machine/machine02.pdf}}
  \hspace{1.25em}
  \vcenteredhbox{\includegraphics{\asydir machine/machine03.pdf}}
  \hspace{1.25em}
  \vcenteredhbox{\includegraphics{\asydir machine/machine04.pdf}}
  \hspace{1.25em}
  \vcenteredhbox{\includegraphics{\asydir machine/machine05.pdf}}
\end{center}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{def:PushdownMachine}
\begin{center}
  \includegraphics{\generalasydir share/machine03.pdf}
\end{center}
The book has details.
We will give a couple of examples.
\end{frame}

\begin{frame}
\begin{example}
This gives the machine as a set of instructions.
(We could instead take it to 
give the inputs and outputs for~$\Delta$.)
\ExecuteMetaData[\catchfilefn]{ex:BalancedParensAcceptedPushdown}
The only accepting state is $q_1$.

These machines always pop the stack before they make a transition.
So Instruction~$0$ must push $\bot$ back on the stack, and then it adds \str{g0}
on top of that.
Instruction~$2$ pops the \str{g0} off and doesn't replace it.

These machines sometimes need to do some action when the tape is exhausted,
so we put a \blank{} to mark the end of the input 
(and assume the input does not contain that character).
\end{example}
\end{frame}


\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:BalancedParensAcceptedPushdownAccept}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:BalancedParensAcceptedPushdownReject}
\end{frame}


\begin{frame}
\begin{example}
\ExecuteMetaData[\catchfilefn]{ex:PalindromesUsingMiddleMarkeri}
\end{example}
\end{frame}


\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:PalindromesUsingMiddleMarkerii}
\end{frame}



\begin{frame}{Pushdown machines with $\varepsilon$ transitions}
\begin{example}
This machine accepts the language of even length palindromes.
\begin{equation*}
\lang_{\text{ELP}}=\set{\sigma\reversal{\sigma}\suchthat\sigma\in\kleenestar{\B}}=\set{\varepsilon,\str{00},\str{11},\str{0000},\str{0110},\str{1001},\str{1111},\ldots}
\end{equation*}
It has $F=\set{q_2}$
as well as $\Gamma=\set{\text{\str{g0}},\str{g1}}$.
\ExecuteMetaData[\catchfilefn]{ex:NondeterministicPushDownAcceptsPalindromesi}

Because this machine can guess, we can have it guess whether the input is 
finished.
So we will omit the terminating \blank{} that we used in the 
two prior examples.
\end{example}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:NondeterministicPushDownAcceptsPalindromesii}  
\end{frame}

\begin{frame}
Here is the branch of the computation tree where the machine
accepts the even-length palindrome string \str{0110}.
\begin{tapesequence}
  \begin{tapesequencetable}
    0 &\tapegraphic{\asydir machine/machine14.pdf} \\
    1 &\tapegraphic{\asydir machine/machine15.pdf} \\
    2 &\tapegraphic{\asydir machine/machine16.pdf} \\
    3 &\tapegraphic{\asydir machine/machine17.pdf} \\
    4 &\tapegraphic{\asydir machine/machine18.pdf} \\
  \end{tapesequencetable}
\end{tapesequence}
\end{frame}

\begin{frame}
Here is the machine's computation tree on input \str{00}.
The $\varepsilon$~transitions go up.
(The relevant instructions are written next to the $\yields$ symbols.)
\begin{center}
  \includegraphics{\asydir pda/pda04.pdf}
\end{center}
As the highlighted branch shows, it accepts.
\end{frame}

\begin{frame}
Here is the machine's full computation tree on input \str{100}.
\begin{center}
  \includegraphics{\asydir pda/pda09.pdf}
\end{center}
None
of the branches end both with an empty string and in an accepting state,
so it rejects the input.
\end{frame}


\begin{frame}{Deterministic Pushdown machines}
The definition that we gave earlier is of a nondeterministic
Pushdown machine.
For the next slide we need to describe deterministic ones.

\ExecuteMetaData[\catchfilefn]{disc:ChomskyHierarchy} 

This section's first two example Pushdown machines are both deterministic. 
\end{frame}

\begin{frame}{Relation between machine types and languages}
Below, the box includes all languages.
That is, fix an alphabet~$\Sigma$ and then
the universe consists of every subset of $\kleenestar{\Sigma}\!$.
\begin{center} \small
  % \mbox{Languages over $\B$:\ }
  \vcenteredhbox{\includegraphics{\asydir pda/pda00.pdf}}
  \hspace{2em}
  \begin{tabular}{rl}
    \tabulartext{Class}  &\tabulartext{Machine type} \\
    \hline
    $A$ &Finite State, including nondeterministic\rule{0em}{2.15ex} \\
    $B$ &deterministic Pushdown \\
    $C$ &nondeterministic Pushdown \\
    $D$ &Turing \\
  \end{tabular}
\end{center}
Class~$A$ consists of the languages that are regular, those decided by
some Finite State machine.
Class~$B$ holds the languages that are decided by some deterministic
Pushdown machine.
Class~$C$ is the languages decided by some nondeterministic
Pushdown machine.
Finally, class~$D$ consists of the languages decided by some Turing machine.
(These are all proper subsets but proof of that 
lies outside of our scope.)

An important point to notice is that 
although for Finite State machines adding nondeterminism
does not change what languages the collection of machines can recognize,
for Pushdown machines it does.
In particular, there is a nondeterministic Pushdown machine that recognizes
the language of palindromes over $\Sigma=\set{\str{a},\str{b}}$.
But no deterministic Pushdown machine can do that\Dash the intuition
is that it has no way to know when to change from pushing to popping. 
\end{frame}




% ====================================================
\section{Regexes}

\begin{frame}
  \frametitle{Regular expressions in practice}

Regular expressions are so useful that they have escaped the theory and
are widely used for symbol manipulation in the wild.

Along the way, they acquired a large number of extensions.
Some of these are conveniences, things that you could do with
the regular expression tools that we have already seen.
But some of these are genuine extensions, which allow you to do 
more than is possible with the regular expressions that we have 
studied.

We shall refer to the in-practice expressions as 
\alert{regexes}.  
\end{frame}


\begin{frame}{Convenience extensions}
Our theory alphabets had two or three characters.
In practice we need at least ASCII's
printable characters:~\str{a}\dash \str{z}, \str{A}\dash \str{Z},
\str{0}\dash \str{9},
space, tab, period, dash, exclamation point, percent sign, dollar sign, 
open and closed parenthesis, open and closed curly braces, etc.\sentencespace
The alphabet may even contain all of Unicode's
more than one hundred thousand characters. 

Regexes allow matching a digit with \re{[0123456789]},
using square brackets as metacharacters.
We can shorten it further to~\re{[0-9]}.
Similarly,
\re{[A-Za-z]} matches a single English letter.

To invert the set of matched characters, put a
caret~`\re{\textasciicircum}' as
the first thing inside the bracket.
Thus, \re{[\textasciicircum 0-9]} matches a non-digit
and \re{[\textasciicircum A-Za-z]} matches a character that is not
an ASCII letter.

The most common lists have short abbreviations.
Another abbreviation for the ASCII digits is
\re{\textbackslash d}.
Use
\re{\textbackslash D} for the ASCII non-digits,
\re{\textbackslash s} for the whitespace characters
(space, tab, newline, formfeed, and line return)
and \re{\textbackslash S} for ASCII characters that are non-whitespace.
Cover
the alphanumeric characters (upper and lower case ASCII letters, digits,
and underscore) with \re{\textbackslash w} 
and cover the complement with \re{\textbackslash W}.
\end{frame}



\begin{frame}
Earlier,
to match  `at most one \str{a}' we used \re{\emptystring|a}.
So we can write something like \re{(|a)}.
But depicting the empty string by just putting nothing there can be confusing.
Modern languages allow you to write
\re{a?} for `at most one \str{a}'.

For `at least one \str{a}'
modern languages use \re{a+}, so the plus sign is another
metacharacter.
More generally, we often want to specify quantities.
For instance, to match five \str{a}'s extended regular expressions use
the curly braces as metacharacters, with \re{a\{5\}}.
Match between two and five of them with 
\re{a\{2,5\}}
and match at least two with \re{a\{2,\}}.
Thus, \re{a+} is shorthand for \re{a\{1,\}}.

\pause
To match a metacharacter, \alert{escape} it with a backslash,~`\str{\textbackslash}'.
Thus, to look for the string `\str{(Note}' put a backslash
before the open parentheses:
\re{\textbackslash (Note}.
Similarly, \re{\textbackslash |} matches a pipe and \re{\textbackslash [}
matches an open square bracket.
And, \re{To be or not to be\textbackslash ?} matches
the famous question. 
Match backslash itself with \re{\textbackslash\textbackslash}.
\end{frame}


\begin{frame}
\begin{example}
US ZIP codes are five digits.
Match them with
\re{\textbackslash d\{5\}}.
\end{example}

\begin{example} \label{ex:NAPhoneNumber}
North American phone numbers match
\re{\textbackslash d\{3\} \textbackslash d\{3\}-\textbackslash d\{4\}}.
\end{example}

\begin{example}  \label{ex:CanadianPostCodes}
Canadian postal codes have seven characters:~the fourth is a space,
the first, third, and sixth are letters, and
the others are digits.
The regular expression
\re{[a-zA-Z]\textbackslash d[a-zA-Z] \textbackslash d[a-zA-Z]\textbackslash d}
describes them.
\end{example}

\begin{example}
Dates are often given in the `dd/mm/yy' format.
This matches:
\re{\textbackslash d\textbackslash d/\textbackslash d\textbackslash d/\textbackslash d\textbackslash d}.
\end{example}

\begin{example} \label{ex:AmerTime}
In the twelve hour time format some typical times
strings are `8:05~am' or `10:15~pm'.
You could use this (note the empty string at the start).
\begin{center}
\re{(|0|1)\textbackslash d:\textbackslash d\textbackslash d\textbackslash s(am|pm)}
\end{center}
Note that it matches some strings that you don't want, 
such as `18:05 am'. 
\end{example}
\end{frame}


\begin{frame}
\begin{example}
The regex \re{(-|\textbackslash +)?\textbackslash d+} matches
an integer, positive or negative.
The question mark makes the sign optional.
The plus sign makes sure there is at least one digit.
\end{example}

\begin{example}
A natural number represented in hexadecimal can contain the usual digits,
along with the additional characters `a' through `f' (sometimes capitalized). 
Programmers often prefix such a representation
with \str{0x}, so the expression is \re{(0x)?[a-fA-F0-9]+}.
\end{example}

\begin{example}
A C language identifier begins with an ASCII
letter or underscore and then can have arbitrarily many more
letters, digits, or underscores:
\re{[a-zA-Z\_]\textbackslash w*}.
\end{example}

\begin{example}
Match a user name of between three and twelve letters, digits, underscores,
or periods with \re{[\textbackslash w\textbackslash .]\{3,12\}}.
Match a password that is at least eight characters long with \re{.\{8,\}}.
\end{example}

\pause
\begin{example}
For email addresses, \re{\textbackslash S+@\textbackslash S+} is
an often used extended expression, as a sanity check.
\end{example}

\begin{example}
Match the text inside a single set of parentheses with 
\re{\textbackslash ([\textasciicircum ()]*\textbackslash )}.
\end{example}

\begin{example}
We next match a URL, a web address such as
\url{https://hefferon.net/computation}.
The regex breaks URL's into~a
scheme such as `\str{http}' along with
a colon and two forward slashes,
a host such as \str{hefferon.net} followed by a slash, and then
a path such as \str{computing}
(the standard also allows a trailing query string 
but this regex does not handle that).
\begin{center}% 
% \re{(https?|ftp)://([textasciicircumflex\textbackslash s/?\textbackslash .#]+\textbackslash .?)\{1,4\}(/[^\textbackslash s]*)?}
\re{(https?|ftp)://([\textasciicircum\textbackslash s/?\textbackslash .\#]+\textbackslash .?)\{0,3\}[\textasciicircum\textbackslash s/?\textbackslash .\#]+(/[\textasciicircum\textbackslash s]*/?)?}
\end{center}
% Notice the question mark in \re{https?}, so that
% the scheme can be \str{http} or \str{https}.
% Notice also that the host part,
% consists of between one and four fields separated by periods.
% We allow almost any character in those fields, except for a space,
% a question mark, a period or a hash.
% At the end comes the path.
\end{example}
\end{frame}


\begin{frame}
As to lines,
you can also match the start of a line and end of line with the metacharacters
caret~`\str{\textasciicircum}' and
dollar sign~`\str{\textdollar}'.

Many programs that use regexes are line-oriented.
They often, by default, match the regex anywhere in the line.

Sometimes, as in Python, there are two modes.
One matches the give regex anywhere in the line, and one
specifically requires you to put in the parts such as start of line
and end of line.
\end{frame}



\begin{frame}{Extensions beyond convenience alone}
\begin{example}
The web language HTML uses tags such as
\str{<b>boldface text</b>} and \str{<i>italicized text</i>}.
Matching any one tag is straightforward, for instance
\re{<b>[\textasciicircum<]*</b>}.

But for a single expression that matches them all,
you would seem to have to do each as a separate
case and then combine cases with a pipe.
However, instead modern regexes allow the system to remember what it finds
at the start and look for that again at the end.

Thus, Racket's regex
\re{<([\textasciicircum >]+)>.*</\textbackslash\textbackslash 1>}
matches HTML tags like the ones given.
Its second character is an open parenthesis, and the
\str{\textbackslash\textbackslash 1} refers to everything between that
open parenthesis and the
matching close parenthesis.
(As you might guess from the \str{1}, you can also have
a second match with \str{\textbackslash\textbackslash 2}, 
etc.)
\end{example}

That is a \definend{back reference}.
It is very convenient, but
it gives regexes
more power than the theoretical regular expressions that we studied earlier.
\end{frame}



\begin{frame}
\begin{example} \label{ex:LangSquares}
This is the language of \definend{squares} over $\Sigma=\set{\str{a},\str{b}}$.
\begin{equation*}
  \lang=
  \set{\sigma\in\kleenestar{\Sigma}
         \suchthat \text{$\sigma=\tau\concat\tau$ for some $\tau\in\kleenestar{\Sigma}$}}
\end{equation*}
Some members are \str{aabaab}, \str{baaabaaa}, and~\str{aa}.
The Pumping Lemma shows that the language of squares is not regular.
Describe this language with the regex \re{(.+)\textbackslash 1}; note
the back-reference. 
\end{example}

\begin{example}
The regex \re{.?|(..+?)\textbackslash\textbackslash 1+} 
matches a unary  number if and only if it is a
not prime.
The group corresponds to a natural number of characters that are matched. 
This group then appears some natural number of times. 
If there is a match then it is possible to find a product of two numbers 
greater than or equal to 2 that match the string.
\end{example}
\end{frame}

\end{document}




